<template>
<div>
    <div class="col-lg-10 col-xl-8 col-md-10 mx-auto my-5">
        <b-card header="Timeline">
            <template #header>
                <h4 class="mb-0">Timeline</h4>
            </template>
            <b-table head-variant="light" bordered hover responsive :items="timeTable"></b-table>
        </b-card>
    </div>
    <div class="col-lg-6 col-xl-4 col-md-6 mx-auto my-5">
        <b-card header-tag="header">
            <template #header>
                <div class="position-relative">
                    <h4 class="mb-0">Timeline Settings</h4>
                    <b-button variant="success" class="roundbutton" @click="showModal = true">+</b-button>
                </div>
            </template>
            <b-card-body class="p-0">
                <div class="mt-5">
                    <draggable v-model="settings" group="settings" @start="drag=true" @end="drag=false">
                        <div v-for="(setting, index) in settings" :key="index" class="border py-2 px-1">{{setting.textRepresentation}}</div>
                    </draggable>
                    <div class="row mt-4" v-if="settings.length != 0">
                        <b-button class="mx-auto" variant="success" @click="submit">Submit</b-button>
                    </div>
                    <div class="row px-4" v-else>
                        <div class="col">
                            <p class="text-black-50">Add timeline settings with the plus button...</p>
                        </div>
                    </div>
                </div>
            </b-card-body>
        </b-card>
    </div>
    <settingmodal :show="showModal" @settingModalClosed="showModal = false" @submitted="addSetting" :settings="settingOptions"></settingmodal>
    <div class="col-lg-6 col-xl-4 col-md-6 mx-auto my-5">
        <b-alert :show="alertCountDown" dismissible fade variant="success" @dismiss-count-down="countDownChanged">
            Summary has been printed to the console...
        </b-alert>
    </div>
</div>
    
</template>

<script>
import settingmodal from "./components/SettingModal"
import draggable from 'vuedraggable'

export default {
    components: {settingmodal, draggable},
    data () {
        return {
            settings: [],
            settingOptions: [],
            showModal: false,
            timeTable: [],
            alertCountDown: 0
        }
    },
    methods: {
        generateSettingOptions () {
            // Generating the hours as options and table columns. The options need 24 hours, the table only 23
            let currhour = 8, currHourFormatted, i = 0, timeTable = {["_cellVariants"]: {}}

            while (currhour <= 24) {
                // this could be done with momentJs, but it formats 24:00 to 0:00, so I rather chose this :D 
                currhour.toString().length == 1 ? currHourFormatted = `0${currhour}:00` : currHourFormatted = `${currhour}:00`

                // the iterator has been used as value, because like and index, it helps matching with the proper hour 
                // when creating the text representation to the list view (see it in function addSetting)
                this.settingOptions.push({ value: i, text: currHourFormatted })

                if (currhour < 24) {
                    timeTable[currHourFormatted] = "Open"
                    timeTable["_cellVariants"][currHourFormatted] = "success"
                }

                i += 1
                currhour += 1
            }

            this.timeTable.push(timeTable)

        },
        addSetting (setting) {
            this.showModal = false

            // Creating text representation
            setting.textRepresentation = `From ${this.settingOptions[setting.from].text} - ${this.settingOptions[setting.to].text} ${setting.status}`

            this.settings.push(JSON.parse(JSON.stringify(setting)))
        },
        submit () {
            this.alertCountDown = 3
            axios.post("/summary", {timetable: this.timeTable[0]}).then(resp => {
                console.log(resp.data.response)
            })
            .catch(er => {
                console.log(er)
            })
        },
        countDownChanged(dismissCountDown) {
            this.alertCountDown = dismissCountDown
        },
    },
    created () {
        this.generateSettingOptions()
    },
    watch: {
        settings: {
            handler () {
                // Re-rendering the table when a new setting has been added or
                // the order of the settings has been changed
                let hour = "", variant = ""

                this.settings.forEach(setting => {
                    setting.status === "Open" ? variant = "success" : variant = "danger"

                    for (let i = setting.from; i < setting.to; i++) {
                        hour = this.settingOptions[i].text
                        this.timeTable[0][hour] = setting.status
                        this.timeTable[0]["_cellVariants"][hour] = variant
                    }
                })
            }
        }
    }
}
</script>

<style scoped>
.roundbutton {
    position: absolute;
    right: 10px;
    bottom: -49px;
    font-size: 1.5rem !important;
    padding: 0 !important;
    margin: 10px;
    overflow: hidden;
    cursor: pointer !important;
    border-radius: 50% !important;
    -webkit-box-shadow: 0 5px 11px 0 rgba(0,0,0,0.18),0 4px 15px 0 rgba(0,0,0,0.15);
    box-shadow: 0 5px 11px 0 rgba(0,0,0,0.18),0 4px 15px 0 rgba(0,0,0,0.15);
    width: 57px;
    height: 57px;
}
</style>
